Index: /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Calendar/3.3/Properties/AssemblyInfo.cs
===================================================================
--- /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Calendar/3.3/Properties/AssemblyInfo.cs	(revision 4422)
+++ /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Calendar/3.3/Properties/AssemblyInfo.cs	(revision 4423)
@@ -58,3 +58,3 @@
 // [assembly: AssemblyVersion("1.0.*")]
 [assembly: AssemblyVersion("3.3.0.0")]
-[assembly: AssemblyFileVersion("3.3.0.4343")]
+[assembly: AssemblyFileVersion("3.3.0.4368")]
Index: /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive 3.3.sln
===================================================================
--- /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive 3.3.sln	(revision 4422)
+++ /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive 3.3.sln	(revision 4423)
@@ -31,6 +31,4 @@
 		HeuristicLab 3.3.vsmdi = HeuristicLab 3.3.vsmdi
 		LocalTestRun.testrunconfig = LocalTestRun.testrunconfig
-		Performance1.psess = Performance1.psess
-		Performance3.psess = Performance3.psess
 		PreBuildEvent.cmd = PreBuildEvent.cmd
 	EndProjectSection
Index: /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/ApplicationConstants.cs
===================================================================
--- /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/ApplicationConstants.cs	(revision 4422)
+++ /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/ApplicationConstants.cs	(revision 4423)
@@ -39,4 +39,14 @@
     
     public static int JOB_TIME_TO_LIVE = 5;
+
+    /// <summary>
+    /// Interval in which the HL.HiveExperiment will poll results from server
+    /// </summary>
+    public static TimeSpan RESULT_POLLING_INTERVAL = new TimeSpan(0, 0, 5);
+
+    /// <summary>
+    /// Maximum number of jobs that the server should send/receive simultaniously
+    /// </summary>
+    public static int MAX_JOB_TRANSFER_COUNT = 6;
   }
 }
Index: /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/BusinessObjects/HeartBeatData.cs
===================================================================
--- /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/BusinessObjects/HeartBeatData.cs	(revision 4422)
+++ /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/BusinessObjects/HeartBeatData.cs	(revision 4423)
@@ -37,5 +37,5 @@
     public int FreeCores { get; set; }
     [DataMember]
-    public Dictionary<Guid, double> JobProgress { get; set; } // TODO: define Type 
+    public Dictionary<Guid, TimeSpan> JobProgress { get; set; } // TODO: define Type
     [DataMember]
     public bool IsAllowedToCalculate { get; set; } // this is true if slave is allowed to work according to calendar
@@ -43,6 +43,6 @@
     public override string ToString() {
       String val = "SlaveId: " + SlaveId + ", FreeCores: " + FreeCores;
-      foreach (KeyValuePair<Guid, double> kvp in JobProgress) {
-        val += "\nId" + kvp.Key + " Progress " + kvp.Value;
+      foreach (KeyValuePair<Guid, TimeSpan> kvp in JobProgress) {
+        val += "\nId" + kvp.Key + " ExecutionTime " + kvp.Value;
       }
       return val;
Index: /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/BusinessObjects/HiveExperimentDto.cs
===================================================================
--- /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/BusinessObjects/HiveExperimentDto.cs	(revision 4423)
+++ /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/BusinessObjects/HiveExperimentDto.cs	(revision 4423)
@@ -0,0 +1,71 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Runtime.Serialization;
+using HeuristicLab.Common;
+using HeuristicLab.DataAccess;
+using HeuristicLab.PluginInfrastructure;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Hive.Contracts.BusinessObjects {
+
+  [StorableClass]
+  [DataContract]
+  [Serializable]
+  public class HiveExperimentDto : PersistableObject {
+    [Storable]
+    [DataMember]
+    public string Name { get; set; }
+    [Storable]
+    [DataMember]
+    public string Description { get; set; }
+    [Storable]
+    [DataMember]
+    public string ResourceIds { get; set; }
+    [Storable]
+    [DataMember]
+    public Guid UserId { get; set; }
+    [Storable]
+    [DataMember]
+    public Guid? RootJobId { get; set; }
+
+    public override string ToString() {
+      return base.ToString() + "Name: " + Name + ", Description: " + Description + ", ResourceIds: " + ResourceIds;
+    }
+
+    public HiveExperimentDto() {
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      HiveExperimentDto clone = (HiveExperimentDto)base.Clone(cloner);
+      clone.Name = this.Name;
+      clone.Description = this.Description;
+      clone.ResourceIds = this.ResourceIds;
+      clone.RootJobId = this.RootJobId;
+      clone.UserId = this.UserId;
+      return clone;
+    }
+  }
+}
Index: /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/BusinessObjects/HiveExperimentDtoList.cs
===================================================================
--- /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/BusinessObjects/HiveExperimentDtoList.cs	(revision 4423)
+++ /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/BusinessObjects/HiveExperimentDtoList.cs	(revision 4423)
@@ -0,0 +1,30 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Common;
+using HeuristicLab.Collections;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Hive.Contracts.BusinessObjects {
+  public class HiveExperimentDtoList : ObservableList<HiveExperimentDto>, IDeepCloneable {
+    public HiveExperimentDtoList() { }
+    public HiveExperimentDtoList(IEnumerable<HiveExperimentDto> collection) {
+      this.list = new List<HiveExperimentDto>(collection);
+    }
+
+    [StorableConstructor]
+    protected HiveExperimentDtoList(bool deserializing) : base(deserializing) { }
+
+    public object Clone() {
+      return Clone(new Cloner());
+    }
+
+    public virtual IDeepCloneable Clone(Cloner cloner) {
+      HiveExperimentDtoList clone = (HiveExperimentDtoList)Activator.CreateInstance(this.GetType());
+      cloner.RegisterClonedObject(this, clone);
+      clone.list = (this.Select(x => (HiveExperimentDto)cloner.Clone(x))).ToList();
+      return clone;
+    }
+  }
+}
Index: /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/BusinessObjects/JobDto.cs
===================================================================
--- /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/BusinessObjects/JobDto.cs	(revision 4422)
+++ /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/BusinessObjects/JobDto.cs	(revision 4423)
@@ -41,5 +41,5 @@
     [Storable]
     [DataMember]
-    public Guid? UserId { get; set; }
+    public Guid UserId { get; set; }
     [Storable]
     [DataMember]
@@ -47,8 +47,8 @@
     [Storable]
     [DataMember]
-    public JobDto ParentJob { get; set; }
+    public Guid? ParentJobId { get; set; }
     [Storable]
     [DataMember]
-    public double? Percentage { get; set; }
+    public TimeSpan ExecutionTime { get; set; }
     [Storable]
     [DataMember]
@@ -104,6 +104,6 @@
       clone.Id = this.Id;
       clone.MemoryNeeded = this.MemoryNeeded;
-      clone.ParentJob = (JobDto)cloner.Clone(this.ParentJob);
-      clone.Percentage = this.Percentage;
+      clone.ParentJobId = this.ParentJobId;
+      clone.ExecutionTime = this.ExecutionTime;
       clone.PluginsNeeded = (from p in this.PluginsNeeded
                              select (HivePluginInfoDto)cloner.Clone(p)).ToList();
Index: /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/BusinessObjects/JobResult.cs
===================================================================
--- /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/BusinessObjects/JobResult.cs	(revision 4422)
+++ /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/BusinessObjects/JobResult.cs	(revision 4423)
@@ -44,5 +44,5 @@
     [Storable]
     [DataMember]
-    public double? Percentage { get; set; }
+    public TimeSpan ExecutionTime { get; set; }
     [Storable]
     [DataMember]
@@ -68,5 +68,5 @@
       clone.DateFinished = this.DateFinished;
       clone.Exception = this.Exception;
-      clone.Percentage = this.Percentage;
+      clone.ExecutionTime = this.ExecutionTime;
       clone.State = this.State;
       clone.ParentJobId = this.ParentJobId;
Index: /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/BusinessObjects/JobState.cs
===================================================================
--- /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/BusinessObjects/JobState.cs	(revision 4422)
+++ /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/BusinessObjects/JobState.cs	(revision 4423)
@@ -6,12 +6,47 @@
 namespace HeuristicLab.Hive.Contracts.BusinessObjects {
   public enum JobState {
+    /// <summary>
+    /// Job is actively calculated on a Slave
+    /// </summary>
     Calculating,
+
+    /// <summary>
+    /// Job is waiting to be calculated
+    /// </summary>
     Offline,
+
+    /// <summary>
+    /// Job as finished and is ready to be collected by the Client
+    /// </summary>
     Finished,
+
+    /// <summary>
+    /// Job is aborted and result can be collected by the Client
+    /// </summary>
     Aborted,
+
+    /// <summary>
+    /// A snapshot has been requested. The calculating slave is responsible for pausing the Job and sending the snapshot to the server. After that state will be SnapshotSent
+    /// </summary>
     SnapshotRequested,
+
+    /// <summary>
+    /// Snapshot has been sent to the server and its calculating again (should'nt it be back to Calculating again?)
+    /// </summary>
     SnapshotSent,
+
+    /// <summary>
+    /// ???
+    /// </summary>
     Pending,
+
+    /// <summary>
+    /// Job as been aborted due to an error. Results are ready to be collected
+    /// </summary>
     Failed,
+
+    /// <summary>
+    /// The job is paused and waits on the server to be sent back to a Slave when all of its child jobs are Finished.
+    /// </summary>
     WaitForChildJobs
   };
Index: /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/BusinessObjects/SerializedJob.cs
===================================================================
--- /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/BusinessObjects/SerializedJob.cs	(revision 4422)
+++ /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/BusinessObjects/SerializedJob.cs	(revision 4423)
@@ -27,4 +27,7 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 using HeuristicLab.Common;
+using System.IO;
+using HeuristicLab.Persistence.Default.Xml;
+using HeuristicLab.Hive.JobBase;
 
 namespace HeuristicLab.Hive.Contracts.BusinessObjects {
@@ -52,4 +55,19 @@
       return Clone(new Cloner());
     }
+
+    public static byte[] Serialize(object obj) {
+      MemoryStream memStream = new MemoryStream();
+      XmlGenerator.Serialize(obj, memStream);
+      byte[] jobByteArray = memStream.ToArray();
+      memStream.Dispose();
+      return jobByteArray;
+    }
+
+    public static T Deserialize<T>(byte[] sjob) {
+      MemoryStream memStream = new MemoryStream(sjob);
+      T job = XmlParser.Deserialize<T>(memStream);
+      memStream.Dispose();
+      return job;
+    }
   }
 }
Index: /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/BusinessObjects/SlaveDto.cs
===================================================================
--- /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/BusinessObjects/SlaveDto.cs	(revision 4422)
+++ /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/BusinessObjects/SlaveDto.cs	(revision 4423)
@@ -35,8 +35,8 @@
     [Storable]
     [DataMember]
-    public int NrOfCores { get; set; }
+    public int? NrOfCores { get; set; }
     [Storable]
     [DataMember]
-    public int NrOfFreeCores { get; set; }
+    public int? NrOfFreeCores { get; set; }
     [Storable]
     [DataMember]
@@ -44,8 +44,8 @@
     [Storable]
     [DataMember]
-    public int Memory { get; set; }
+    public int? Memory { get; set; }
     [Storable]
     [DataMember]
-    public int FreeMemory { get; set; }
+    public int? FreeMemory { get; set; }
     [Storable]
     [DataMember]
Index: /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/Disposable.cs
===================================================================
--- /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/Disposable.cs	(revision 4422)
+++ /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/Disposable.cs	(revision 4423)
@@ -1,3 +1,23 @@
-﻿using System;
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+using System;
 
 namespace HeuristicLab.Hive.Contracts {
Index: /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/HeuristicLab.Hive.Contracts-3.3.csproj
===================================================================
--- /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/HeuristicLab.Hive.Contracts-3.3.csproj	(revision 4422)
+++ /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/HeuristicLab.Hive.Contracts-3.3.csproj	(revision 4423)
@@ -119,4 +119,6 @@
     <Compile Include="BusinessObjects\CachedHivePluginInfoDto.cs" />
     <Compile Include="BusinessObjects\CalendarState.cs" />
+    <Compile Include="BusinessObjects\HiveExperimentDtoList.cs" />
+    <Compile Include="BusinessObjects\HiveExperimentDto.cs" />
     <Compile Include="BusinessObjects\SerializedJobList.cs" />
     <Compile Include="BusinessObjects\SlaveGroupDto.cs" />
Index: /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/HiveRoles.cs
===================================================================
--- /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/HiveRoles.cs	(revision 4422)
+++ /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/HiveRoles.cs	(revision 4423)
@@ -1,3 +1,23 @@
-﻿using System;
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+using System;
 using System.Collections.Generic;
 using System.Linq;
Index: /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/Interfaces/IClientFacade.cs
===================================================================
--- /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/Interfaces/IClientFacade.cs	(revision 4422)
+++ /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/Interfaces/IClientFacade.cs	(revision 4423)
@@ -49,4 +49,19 @@
     [OperationContract]
     ResponseObject<JobResultList> GetChildJobResults(Guid? parentJobId, bool recursive, bool includeParent);
+
+    /// <summary>
+    /// Returns all experiments for the current user
+    /// </summary>
+    [OperationContract]
+    ResponseObject<HiveExperimentDtoList> GetHiveExperiments();
+    
+    [OperationContract]
+    ResponseObject<HiveExperimentDto> UpdateHiveExperiment(HiveExperimentDto hiveExperimentDto);
+
+    [OperationContract]
+    Response DeleteHiveExperiment(Guid hiveExperimentId);
+
+    [OperationContract]
+    ResponseObject<JobDto> AddChildJob(Guid parentJobId, SerializedJob serializedJob);
   }
 }
Index: /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/Interfaces/IJobManager.cs
===================================================================
--- /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/Interfaces/IJobManager.cs	(revision 4422)
+++ /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/Interfaces/IJobManager.cs	(revision 4423)
@@ -97,4 +97,16 @@
     [OperationContract]
     ResponseObject<JobDto> PauseJob(SerializedJob serializedJob);
+
+    [OperationContract]
+    ResponseObject<HiveExperimentDtoList> GetHiveExperiments();
+
+    [OperationContract]
+    ResponseObject<HiveExperimentDto> UpdateHiveExperiment(HiveExperimentDto hiveExperimentDto);
+
+    [OperationContract]
+    Response DeleteHiveExperiment(Guid hiveExperimentId);
+
+    [OperationContract]
+    Response DeleteChildJobs(Guid jobId);
   }
 }
Index: /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/Interfaces/ILifecycleManager.cs
===================================================================
--- /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/Interfaces/ILifecycleManager.cs	(revision 4422)
+++ /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/Interfaces/ILifecycleManager.cs	(revision 4423)
@@ -26,33 +26,29 @@
 using HeuristicLab.DataAccess.Interfaces;
 
-namespace HeuristicLab.Hive.Contracts.Interfaces {    
+namespace HeuristicLab.Hive.Contracts.Interfaces {
   /// <summary>
   /// Manages the lifecycle of the application
   /// </summary>
-  public interface ILifecycleManager {    
+  public interface ILifecycleManager {
     /// <summary>
     /// Initializes the application
     /// </summary>
-    void Init();
-
-    /// <summary>
-    /// The server heartbeat
-    /// </summary>
-    void RegisterHeartbeat(EventHandler handler);
-
-    /// <summary>
-    /// The startup event
-    /// </summary>
-    void RegisterStartup(EventHandler handler);
-
-    /// <summary>
-    /// The shutdown event
-    /// </summary>
-    void RegisterShutdown(EventHandler handler);
+    void Start();
 
     /// <summary>
     /// Shuts the application down
     /// </summary>
-    void Shutdown();
+    void Stop();
+
+    /// <summary>
+    /// The number of jobs which are transferred at the moment
+    /// </summary>
+    int JobsCurrentlyTransferring { get; set; }
+
+    event EventHandler ServerHeartbeat;
+
+    event EventHandler Started;
+
+    event EventHandler Stopped;
   }
 }
Index: /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/Interfaces/ISlaveCommunicator.cs
===================================================================
--- /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/Interfaces/ISlaveCommunicator.cs	(revision 4422)
+++ /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/Interfaces/ISlaveCommunicator.cs	(revision 4423)
@@ -50,8 +50,8 @@
 
     [OperationContract]
-    ResponseResultReceived StoreFinishedJobResult(Guid clientId, Guid jobId, byte[] result, double percentage, string exception);
+    ResponseResultReceived StoreFinishedJobResult(Guid clientId, Guid jobId, byte[] result, TimeSpan executionTime, string exception);
 
     [OperationContract]
-    ResponseResultReceived ProcessSnapshot(Guid clientId, Guid jobId, byte[] result, double percentage, string exception);
+    ResponseResultReceived ProcessSnapshot(Guid clientId, Guid jobId, byte[] result, TimeSpan executionTime, string exception);
 
     [OperationContract]
Index: /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/Interfaces/ISlaveFacade.cs
===================================================================
--- /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/Interfaces/ISlaveFacade.cs	(revision 4422)
+++ /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/Interfaces/ISlaveFacade.cs	(revision 4423)
@@ -56,4 +56,7 @@
     [OperationContract]
     SerializedJob GetLastSerializedResult(Guid jobId);
+
+    [OperationContract]
+    Response DeleteChildJobs(Guid jobId);
   }
 }
Index: /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/MessageContainer.cs
===================================================================
--- /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/MessageContainer.cs	(revision 4422)
+++ /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/MessageContainer.cs	(revision 4423)
@@ -40,5 +40,6 @@
       FetchOrForceFetchCalendar, AddChildJob,
       PauseJob,
-      GetChildJobs
+      GetChildJobs,
+      DeleteChildJobs
     };
 
Index: /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/MessageContainerWithCallback.cs
===================================================================
--- /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/MessageContainerWithCallback.cs	(revision 4422)
+++ /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/MessageContainerWithCallback.cs	(revision 4423)
@@ -1,3 +1,23 @@
-﻿using System;
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+using System;
 using HeuristicLab.Common;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
Index: /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/ResponseStatus.cs
===================================================================
--- /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/ResponseStatus.cs	(revision 4422)
+++ /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/ResponseStatus.cs	(revision 4423)
@@ -1,3 +1,23 @@
-﻿using System;
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+using System;
 using System.Collections.Generic;
 using System.Linq;
@@ -5,7 +25,4 @@
 
 namespace HeuristicLab.Hive.Contracts {
-  /// <summary>
-  /// [chn] todo: make names consistent: NotFound, DoesNotExist, NotAvailable, ...
-  /// </summary>
   public enum ResponseStatus {
     Ok,
@@ -18,5 +35,5 @@
     GetJobByIdWithDetails_JobDoesNotExist, // ApplicationConstants.RESPONSE_JOB_JOB_DOESNT_EXIST
 
-    AddNewJob_JobStateMustBeOffline, // ApplicationConstants.RESPONSE_JOB_JOBSTATE_MUST_BE_OFFLINE
+    AddNewJob_InvalidJobState, // ApplicationConstants.RESPONSE_JOB_JOBSTATE_MUST_BE_OFFLINE
     AddNewJob_JobIdMustNotBeSet, // ApplicationConstants.RESPONSE_JOB_ID_MUST_NOT_BE_SET
     AddNewJob_JobNull, // ApplicationConstants.RESPONSE_JOB_JOB_NULL
@@ -30,8 +47,8 @@
     AbortJob_JobIsNotBeeingCalculated, // ApplicationConstants.RESPONSE_JOB_IS_NOT_BEEING_CALCULATED
 
-    GetCalendar_ResourceNotFound, // ApplicationConstants.RESPONSE_CLIENT_RESOURCE_NOT_FOUND
+    GetCalendar_ResourceDoesNotExist, // ApplicationConstants.RESPONSE_CLIENT_RESOURCE_NOT_FOUND
     GetCalendar_NoCalendarFound, // ApplicationConstants.RESPONSE_UPTIMECALENDAR_NO_CALENDAR_FOUND
 
-    SetCalendarStatus_ResourceNotFound, // ApplicationConstants.RESPONSE_CLIENT_RESOURCE_NOT_FOUND
+    SetCalendarStatus_ResourceDoesNotExist, // ApplicationConstants.RESPONSE_CLIENT_RESOURCE_NOT_FOUND
 
     ProcessHeartBeat_UserNotLoggedIn, // ApplicationConstants.RESPONSE_COMMUNICATOR_USER_NOT_LOGGED_IN
@@ -60,8 +77,11 @@
     DeleteResourceFromGroup_SlaveGroupDoesNotExist, // ApplicationConstants.RESPONSE_CLIENT_CLIENTGROUP_DOESNT_EXIST
 
-    GetAllGroupsOfResource_ResourceNotFound, // ApplicationConstants.RESPONSE_CLIENT_RESOURCE_NOT_FOUND
+    GetAllGroupsOfResource_ResourceDoesNotExist, // ApplicationConstants.RESPONSE_CLIENT_RESOURCE_NOT_FOUND
 
     DeleteSlaveGroup_SlaveGroupDoesNotExist, // ApplicationConstants.RESPONSE_CLIENT_CLIENTGROUP_DOESNT_EXIST
 
+    GetLastSerializedResult_JobDoesNotExist,
+    DeleteHiveExperiment_Failed,
+    DeleteChildJobs_Failed,
   }
 }
Index: /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/StreamedObject.cs
===================================================================
--- /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/StreamedObject.cs	(revision 4422)
+++ /branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/StreamedObject.cs	(revision 4423)
@@ -1,3 +1,23 @@
-﻿using System;
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+using System;
 using System.Collections.Generic;
 using System.Linq;
